sc::Optimize Class Referenceabstract

The Optimize class is an abstract base class for classes that find the extreme points of Function's. More...

`#include <opt.h>`

Inheritance diagram for sc::Optimize:
[legend]
Collaboration diagram for sc::Optimize:
[legend]

## Public Member Functions

| Optimize (StateIn &)
| Restore the state of a Function object.
| Optimize (const Ref< KeyVal > &)
| The KeyVal constructor reads the following information: More...
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
virtual int | optimize ()
| Do the optimization. More...
void | set_checkpoint ()
| Set up for checkpointing.
void | set_checkpoint_file (const char *)
void | set_function (const Ref< Function > &)
| Set the function to be optimized.
void | set_max_iterations (int)
| Set the iteration limit.
virtual void | init ()
| Initialize the optimizer.
virtual int | update ()=0
| Take a step. More...
virtual void | apply_transform (const Ref< NonlinearTransform > &)
Ref< Function > | function () const
| Returns information about the Function being optimized.
Ref< SCMatrixKit > | matrixkit () const
RefSCDimension | dimension () const
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Attributes

int | max_iterations_
int | n_iterations_
int | ckpt_
int | print_timings_
double | max_stepsize_
char * | ckpt_file
Ref< Function > | function_
Ref< Convergence > | conv_

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

The Optimize class is an abstract base class for classes that find the extreme points of Function's.

## Constructor & Destructor Documentation

sc::Optimize::Optimize | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor reads the following information:

`checkpoint`

  If true, the optimization will be checkpointed. The default is false.

`checkpoint_file`

  The name of the checkpoint file. The name defaults to opt_ckpt.dat.

`max_iterations`

  The maximum number of interations. The default is 10.

`max_stepsize`

  The maximum stepsize. The default is 0.6.

`function`

  A Function object. There is no default.

`convergence`

  This can be either a floating point number or a Convergence object. If it is a floating point number then it is the convergence criterion. See the description Convergence class for the default.

## Member Function Documentation

virtual int sc::Optimize::optimize | ( |  | ) |

virtual

Do the optimization.

Returns nonzero if the optimization is complete.

void sc::Optimize::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

Reimplemented in sc::LineOpt, sc::QNewtonOpt, and sc::SteepestDescentOpt.

virtual int sc::Optimize::update | ( |  | ) |

pure virtual

Take a step.

Returns 1 if the optimization has converged, otherwise 0.

Implemented in sc::Backtrack, sc::QNewtonOpt, sc::EFCOpt, sc::GDIISOpt, sc::MCSearch, sc::NewtonOpt, and sc::SteepestDescentOpt.

The documentation for this class was generated from the following file:

- opt.h